
/**
 * Klasse Caesar.
 * 
 * @author (claus albowski) 
 * @version (Jan'06)
 */
public class Caesar 
implements CaesarInterface
{
    // Instanzvariable
    String original, code;
    char key;
    boolean originalTextEingegeben, codeTextEingegeben, 
            schluesselEingegeben, istCodiert, istDecodiert;


    /**
     * Konstruktor fr Objekte der Klasse Caesar
     */
    public Caesar()
    {
        // Instanzvariable initialisieren
        original=code=null; 
        key = '\u0000';
        originalTextEingegeben=codeTextEingegeben=schluesselEingegeben
                  =istCodiert=istDecodiert=false;
    }
    // ffentliche Methoden:
    
    
    /**
     * gibt jeweils den bearbeiteten Text aus.
     */
    public String zeigeText(){
        if (istDecodiert) return original;
        else if (istCodiert) return code;
        else return "Keine Bearbeitung!";
    }
    
    /**
     * setzt den Originaltext
     */
    public void setzeOriginalText(String text){
        original=text;
        code = null;
        originalTextEingegeben=true;
        istCodiert=istDecodiert=false;
    }

    /**
     * setzt den Codetext
     */
    public void setzeCodetext(String text){
        code=text;
        original =  null;
        codeTextEingegeben=true;
        istCodiert=istDecodiert=false;
    }

    /**
     * setzt den Schluessel
     */
    public void setzeSchluessel(char schluessel){
        key=schluessel;
        schluesselEingegeben=true;
    }

    /**
     * verschluesselt den eingegebenen Text
     */
    public void verschluessele(){
        if (originalTextEingegeben){
            code = verschluessele(original, (int) key);
            istCodiert=true;
        }
    }

    /**
     * entschluesselt den eingegebenen Text
     */
    public void entschluessele(){
        if (codeTextEingegeben){
            original = verschluessele(code, - (int) key);
            istDecodiert=true;
        }
    }
    
    /**
     * prft, ob ein Zeichen Grobuchstabe ist.
     */
    public boolean istGrossBuchstabe(Character c){
        return !((c.compareTo('A')<0)||(c.compareTo('Z')>0));
        // interessanterweise wird  zu ss vorher! konvertiert!
    }
    
    
    // private Methoden:
    
    /**
     * fhrt das verschlsseln aus
     */
    private String verschluessele(String text, int key){
        text = entferneSonderzeichen(text.toUpperCase());
        char c;
        StringBuffer temp = new StringBuffer();
        for (int i=0; i<text.length(); i++){
            c = text.charAt(i);
            int buchstabe = c; // Character.digit(c,10);
            buchstabe = ((buchstabe+key+26) % 26)+65;
            c = (char) buchstabe;
            temp.append(c);
        }
        return temp.toString();
    }
    
    /**
     * entfernt die Sonderzeichen aus dem Text.
     */
    private String entferneSonderzeichen(String text){
        StringBuffer temp = new StringBuffer();
        for (int i=0; i<text.length();i++)
        if (istGrossBuchstabe(text.charAt(i)))
        temp.append(text.charAt(i));
        return new String(temp);
    }
    
}

